/******************************************************************************/
/*	apci8133s.c																  */
/*																			  */
/*	aPCI-8133															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	Date 1999/05/27															  */
/*																			  */
/*	̿ɂׯ߰֐̎gpႪLqĂ܂B						  */
/*																			  */
/******************************************************************************/
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "apci8133w.h"

const TCHAR szTitle[] = _T("Sample");
const TCHAR sz8133[]   = _T("aPCI-8133");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);

//---------------------------------------------------------------------------
// Ҳ
//---------------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR szbuf[256];
	DWORD dwDLLVer, dwDriverVer;
	BOOL  bResult;					// 
	WORD  wLogSlot;					// ޲̘_ۯĔԍi[
	BYTE  b;
	APCI8133RESOURCE ri;			// ؿ
	DWORD dwSwVal;					// ۰ذ̒l


	//-----------------------------------------------------------------------
	// apci8133.dll ̎gp錾
	//-----------------------------------------------------------------------
	if (Apci8133wDllOpen() == FALSE){
		ErrorMessage(APCI8133_SLOT_AUTO);
		return 1;					// apci8133.dll ۰ނɎs܂
	}
	//-----------------------------------------------------------------------
	// ްޮݔԍ\
	// aPCI-8133 DLL,ײްްޮݔԍ擾
	//-----------------------------------------------------------------------
	if (Apci8133wGetVersion(&dwDLLVer, &dwDriverVer) == FALSE){
		ErrorMessage(APCI8133_SLOT_AUTO);
		return 1;
	}
	wsprintf(szbuf, _T("GetVersion\n")
					_T("DLL Version   : %08lxh\n")
					_T("Driver Version: %08lxh"),
					dwDLLVer,
					dwDriverVer);
	ResultMessage(szbuf);
	//-----------------------------------------------------------------------
	// aPCI-8133̎gp錾
	//-----------------------------------------------------------------------
	wLogSlot = APCI8133_SLOT_AUTO;		// gp޲T܂B
	bResult = Apci8133wCreate(&wLogSlot);	// ꍇA̎޲̗ϗۯĔԍi[܂B
	if (bResult == FALSE){				// ޲܂B
		ErrorMessage(APCI8133_SLOT_AUTO);
		return 1;
	}
	wsprintf(szbuf, _T("aPCI-8133 Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);
	ResultMessage(szbuf);
	//-----------------------------------------------------------------------
	// ؿ擾
	//-----------------------------------------------------------------------
	if (Apci8133wGetResource(wLogSlot, &ri) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	if (Apci8133wGetSwitchValue(wLogSlot, &dwSwVal) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	
	wsprintf(szbuf, _T("Board Name: %s\n")
					_T("NumPorts  : %2d\n")
					_T("IO Address: %04xh-%04xh\n")
					_T("Switch    : %01X\n"),
					sz8133,
					ri.dwIOPortLength[1],
					ri.dwIOPortBase[1],
					ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1,
					dwSwVal);
	ResultMessage(szbuf);
	//-----------------------------------------------------------------------
	// Port 1 ɔCӂްo
	// oް AAh
	//-----------------------------------------------------------------------
	b = (BYTE)0xAA;
	if (Apci8133wOutPort(wLogSlot, APCI8133_PORT_1, b) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szbuf, _T("Port 1 փf[^o\n")
					_T("Port 1 Out Data: %02xh"),
					 b);
	ResultMessage(szbuf);
	//-----------------------------------------------------------------------
	// aPCI-8133̎gpJ
	//-----------------------------------------------------------------------
	if (Apci8133wClose(wLogSlot) == FALSE){
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("aPCI-8133 Closed"));
	//-----------------------------------------------------------------------
	// apci8133.dll ̎gpJ
	//-----------------------------------------------------------------------
	if (Apci8133wDllClose() == FALSE){
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;			// apci8133.dll ̃A۰ނɎs܂B
	}
	return 0;
}
//---------------------------------------------------------------------------
// ʂ\
//---------------------------------------------------------------------------
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------
// װүނ\
//---------------------------------------------------------------------------
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Apci8133wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes){
		case APCI8133_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxh"),
							GetLastError());
			break;
		case APCI8133_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;
		default:
			wsprintf(szbuf, _T("aPCI-8133 error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}
	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
